module MD5.Binary where

import Data.Bits
import Data.Word
import Data.Int
import Data.List
import qualified Data.ByteString.Lazy as B

pack8B  :: B.ByteString -> Word8
pack8B  = B.foldl' (\w b -> shiftL w 8 .|. fromIntegral b) 0 . B.take 1

pack16B :: B.ByteString -> Word16
pack16B = B.foldl' (\w b -> shiftL w 8 .|. fromIntegral b) 0 . B.take 2

pack32B :: B.ByteString -> Word32
pack32B = B.foldl' (\w b -> shiftL w 8 .|. fromIntegral b) 0 . B.take 4

pack64B :: B.ByteString -> Word64
pack64B = B.foldl' (\w b -> shiftL w 8 .|. fromIntegral b) 0 . B.take 8




unpack_B :: (Integral b, Bits b) => Int -> b -> [Word8]
unpack_B n w = map (\i -> fromIntegral $ shiftR w i) [(n-8), (n-16) .. 0]

unpack8B  :: Word8 -> [Word8]
unpack8B  = unpack_B 8

unpack16B :: Word16 -> [Word8]
unpack16B = unpack_B 16

unpack32B :: Word32 -> [Word8]
unpack32B = unpack_B 32

unpack64B :: Word64 -> [Word8]
unpack64B = unpack_B 64



splitN :: Int64 -> B.ByteString -> [B.ByteString]
splitN n = unfoldr (\xs -> if B.null xs then Nothing else Just $ B.splitAt n xs)
