module MD5.Compress (compress_block) where

import Data.Bits
import Data.Word
import Data.List

import MD5.Types
import MD5.Constants
import MD5.Hex

compress_block :: State -> Block -> State
compress_block s0 ws = add_state s0 $ foldl' (\s r -> compress1 s ws r) s0 round_table

compress0 :: State -> Block -> (Int, Word32, State -> Word32, Word8) -> Word32
compress0 s@(State a b c d) ws (r, k, f, g) = b + rotateL (a + f s + k + ws ! g) r

compress1 :: State -> Block -> (Int, Word32, State -> Word32, Word8) -> State
compress1 s@(State a b c d) ws rs = State d (compress0 s ws rs) b c

add_state :: State -> State -> State
add_state (State a0 b0 c0 d0) (State a1 b1 c1 d1) = State (a0+a1) (b0+b1) (c0+c1) (d0+d1)
