module MD5.Hex where

import Data.Bits
import Data.Word
import Data.List

import MD5.Binary

hex4 :: (Integral i) => i -> Char
hex4 = genericIndex "0123456789ABCDEF"

hex8 :: Word8 -> String
hex8 x = map hex4 [shiftR x 4, x .&. 0x0F]

hex16 :: Word16 -> String
hex16 = concatMap hex8 . unpack16B

hex32 :: Word32 -> String
hex32 = concatMap hex8 . unpack32B

hex64 :: Word64 -> String
hex64 = concatMap hex8 . unpack64B
