{-# LANGUAGE BangPatterns #-}

module MD5.Pad (pad) where

import Data.Word
import qualified Data.ByteString.Lazy as B

import MD5.Types
import MD5.Constants
import MD5.Binary

pad :: B.ByteString -> [Block]
pad = work 0 . (`B.append` B.pack [0x80])
  where
    work :: Word64 -> B.ByteString -> [Block]
    work !n bs =
      let (bs0,bs1) = B.splitAt 64 bs
      in
        if B.null bs1
          then map make_block_bs $ final n bs
          else make_block_bs bs0 : work (n + block_size_bytes) bs1

    final :: Word64 -> B.ByteString -> [B.ByteString]
    final n bs =
      let
        l  = B.length bs
        lf = B.pack $ reverse $ unpack64B $ 8*((n + fromIntegral l) - 1)
      in
        if l <= 64 - 8
          then [bs `B.append` B.replicate (64 - 8 - l) 0x00 `B.append` lf]
          else [bs `B.append` B.replicate (64   -   l) 0x00, B.replicate (64 - 8) 0x00 `B.append` lf]
