module MD5.Types where

import Data.Bits
import Data.Word
import Data.List
import Data.Array.Unboxed
import qualified Data.ByteString.Lazy as B
import Data.Binary
import Data.Binary.Get
import Control.Monad

import MD5.Binary
import MD5.Hex

data State = State {-# UNPACK #-} !Word32
                   {-# UNPACK #-} !Word32
                   {-# UNPACK #-} !Word32
                   {-# UNPACK #-} !Word32

instance Show State where
  show (State a b c d) = "State " ++ unwords (map hex32 [a,b,c,d])

hex_hash :: State -> String
hex_hash (State a b c d) = concatMap (concatMap hex8 . reverse . unpack32B) [a,b,c,d]



newtype Block = Block {unpack :: UArray Word8 Word32}

instance Show Block where
  show (Block b) = unlines (map hex32 (elems b))

make_block_list :: [Word32] -> Block
make_block_list = Block . listArray (0,15)

instance Binary Block where
    put = undefined
    get = do
        xs <- replicateM 16 getWord32le
        return $ Block $ (listArray (0, 15) xs)

make_block_bs :: B.ByteString -> Block
make_block_bs = decode

b ! i = (unpack b) Data.Array.Unboxed.! i
